@ECHO OFF
REM ===========================================================================
REM  HISTORIK.BAT               1.007                               21.10.2022
REM ===========================================================================
REM  Startprogramm zu HISTORIK in QBASIC
REM ===========================================================================
REM  Besonderheiten:
REM  Bei Sprungmarken beachtet MS-DOS 3.30 nur die ersten 8 Buchstaben!
REM ===========================================================================
REM  Bearbeitung: 29.11.1994 - 21.10.2022 Norbert Sdland
REM ===========================================================================

REM Ein temporres Verzeichnis wird eingerichtet und QBASIC installiert:
REM --------------------------------------------------------------------
REM Es besteht auch die Mglichkeit, HISTORIKTEMP direkt zu vorzugeben!
REM -------------------------------------------------------------------
IF NOT x%DOSDRV%x==x SET SYSTEMDRIVE=%DOSDRV%
IF x%SYSTEMDRIVE%x==xx SET SYSTEMDRIVE=C:
IF NOT x%TEMP%x==xx GOTO 2_Weiter
IF NOT x%TMP%x==xx GOTO 1_Weiter
MKDIR %SYSTEMDRIVE%\TEMP
SET TEMP=%SYSTEMDRIVE%\TEMP
GOTO 2_Weiter
:1_Weiter
SET TEMP=%TMP%
:2_Weiter
SET QBASICTEMP=%TEMP%
IF NOT EXIST INSTALL.BAT GOTO 1_Fehler
CALL INSTALL.BAT

REM Das Programm ist auf die CODEPAGE 437 ausgerichtet:
REM ---------------------------------------------------
IF x%WINDIR%x==xx GOTO 1_DosPfad
IF EXIST %WINDIR%\SYSTEM32\EGA.CPI GOTO WindowsNT
IF EXIST %WINDIR%\COMMAND\EGA.CPI GOTO Windows95
:1_DosPfad
IF EXIST %SYSTEMDRIVE%\DOS\EGA.CPI GOTO Dos
IF EXIST %DOSDIR%\CPI\EGA.CPX Goto FreeDos
KEYB GR 437
ECHO Datei EGA.CPI wurde nicht gefunden.
ECHO Darum wird nun die CODEPAGE 437 voraus gesetzt.
PAUSE
GOTO Start
:Dos
MODE CON CODEPAGE PREPARE=((437) %SYSTEMDRIVE%\DOS\EGA.CPI)
KEYB GR,437,%SYSTEMDRIVE%\DOS\KEYBOARD.SYS
MODE CON CODEPAGE SELECT=437
GOTO Start
:FreeDos
SET LANG=DE
SET DIRCMD=/Y
LH DISPLAY CON=(EGA,,1)
MODE CON CP PREP=((437) %DOSDIR%\CPI\EGA.CPX)
MODE CON CP SEL=437
MODE CON CP REFRESH
MKEYB GR
GOTO Start
:Windows95
MODE CON CODEPAGE PREPARE=((437) %WINDIR%\COMMAND\EGA.CPI)
IF EXIST %WINDIR%\COMMAND\KEYB.COM KEYB GR,437,%WINDIR%\COMMAND\KEYBOARD.SYS
IF NOT EXIST %WINDIR%\COMMAND\KEYB.COM KEYBOARD GR,437,%WINDIR%\COMMAND\KEYBOARD.SYS
MODE CON CODEPAGE SELECT=437
GOTO Start
:WindowsNT
MODE CON CODEPAGE PREPARE=((437) %WINDIR%\SYSTEM32\EGA.CPI)
REM KEYB GR,437,%WINDIR%\SYSTEM32\KEYBOARD.SYS
MODE CON CODEPAGE SELECT=437
CHCP 437

REM Eigentlicher Programmstart:
REM ---------------------------
:Start
IF NOT EXIST HISTORIK.BAS GOTO 2_Fehler
ECHO Versuch, das Programm "QBASIC.EXE" zu laden:
QBASIC.EXE /H /RUN HISTORIK.BAS

REM Eventuell Dateien ausdrucken:
REM -----------------------------
IF x%HISTORIKTEMP%x==xx GOTO 3_Weiter
IF NOT EXIST %HISTORIKTEMP%\DRUCKEN.JA GOTO 112_VGL
ECHO Bitte Drucker startklar machen.
PAUSE
ECHO Ausdruck klein und doppelt: Eigene Routine verwenden!
@ECHO ON
DRUCKE %HISTORIKTEMP%\*.DR* K D
@ECHO OFF
DEL %HISTORIKTEMP%\DRUCKEN.JA
PAUSE
GOTO Start

:3_Weiter
IF x%QBASICTEMP%x==xx GOTO 4_Weiter
IF NOT EXIST %QBASICTEMP%\HISTORIK.TMP\DRUCKEN.JA GOTO 212_VGL
ECHO Bitte Drucker startklar machen.
PAUSE
ECHO Ausdruck klein und doppelt: Eigene Routine verwenden!
@ECHO ON
DRUCKE %QBASICTEMP%\HISTORIK.TMP\*.DR* K D
@ECHO OFF
DEL %QBASICTEMP%\HISTORIK.TMP\DRUCKEN.JA
PAUSE
GOTO Start

:4_Weiter
IF NOT EXIST HISTORIK.TMP\DRUCKEN.JA GOTO 312_VGL
ECHO Bitte Drucker startklar machen.
PAUSE
ECHO Ausdruck klein und doppelt: Eigene Routine verwenden!
@ECHO ON
DRUCKE HISTORIK.TMP\*.DR* K D
@ECHO OFF
DEL HISTORIK.TMP\DRUCKEN.JA
PAUSE
GOTO Start

REM Fehlerbehandlung:
REM -----------------
:1_Fehler
ECHO Das Programm "INSTALL.BAT" fehlt.
PAUSE
GOTO Ende
:2_Fehler
ECHO Das Programm "HISTORIK.BAS" fehlt.
PAUSE
GOTO Ende

REM Zum Schluss Ergebnisse vergleichen:
REM -----------------------------------
:112_VGL
IF NOT EXIST %HISTORIKTEMP%\1\*.* GOTO 123_VGL
IF NOT EXIST %HISTORIKTEMP%\2\*.* GOTO 113_VGL
FC %HISTORIKTEMP%\1\*.HQL %HISTORIKTEMP%\2\*.HQL | MORE
PAUSE
DIR /P %HISTORIKTEMP%\1\*.LST
PAUSE
DIR /P %HISTORIKTEMP%\2\*.LST
PAUSE

:113_VGL
IF NOT EXIST %HISTORIKTEMP%\3\*.* GOTO 114_VGL
FC %HISTORIKTEMP%\1\*.HQL %HISTORIKTEMP%\3\*.HQL | MORE
PAUSE
DIR /P %HISTORIKTEMP%\1\*.LST
PAUSE
DIR /P %HISTORIKTEMP%\3\*.LST
PAUSE

:114_VGL
IF NOT EXIST %HISTORIKTEMP%\4\*.* GOTO 123_VGL
FC %HISTORIKTEMP%\1\*.HQL %HISTORIKTEMP%\4\*.HQL | MORE
PAUSE
DIR /P %HISTORIKTEMP%\1\*.LST
PAUSE
DIR /P %HISTORIKTEMP%\4\*.LST
PAUSE

:123_VGL
IF NOT EXIST %HISTORIKTEMP%\2\*.* GOTO 134_VGL
IF NOT EXIST %HISTORIKTEMP%\3\*.* GOTO 124_VGL
FC %HISTORIKTEMP%\2\*.HQL %HISTORIKTEMP%\3\*.HQL | MORE
PAUSE
DIR /P %HISTORIKTEMP%\2\*.LST
PAUSE
DIR /P %HISTORIKTEMP%\3\*.LST
PAUSE

:124_VGL
IF NOT EXIST %HISTORIKTEMP%\4\*.* GOTO 212_VGL
FC %HISTORIKTEMP%\2\*.HQL %HISTORIKTEMP%\4\*.HQL | MORE
PAUSE
DIR /P %HISTORIKTEMP%\2\*.LST
PAUSE
DIR /P %HISTORIKTEMP%\4\*.LST
PAUSE

:134_VGL
IF NOT EXIST %HISTORIKTEMP%\4\*.* GOTO 212_VGL
FC %HISTORIKTEMP%\3\*.HQL %HISTORIKTEMP%\4\*.HQL | MORE
PAUSE
DIR /P %HISTORIKTEMP%\3\*.LST
PAUSE
DIR /P %HISTORIKTEMP%\4\*.LST
PAUSE
GOTO Ende


:212_VGL
IF NOT EXIST %QBASICTEMP%\HISTORIK.TMP\1\*.* GOTO 223_VGL
IF NOT EXIST %QBASICTEMP%\HISTORIK.TMP\2\*.* GOTO 213_VGL
FC %QBASICTEMP%\HISTORIK.TMP\1\*.HQL %QBASICTEMP%\HISTORIK.TMP\2\*.HQL | MORE
PAUSE
DIR /P %QBASICTEMP%\HISTORIK.TMP\1\*.LST
PAUSE
DIR /P %QBASICTEMP%\HISTORIK.TMP\2\*.LST
PAUSE

:213_VGL
IF NOT EXIST %QBASICTEMP%\HISTORIK.TMP\3\*.* GOTO 214_VGL
FC %QBASICTEMP%\HISTORIK.TMP\1\*.HQL %QBASICTEMP%\HISTORIK.TMP\3\*.HQL | MORE
PAUSE
DIR /P %QBASICTEMP%\HISTORIK.TMP\1\*.LST
PAUSE
DIR /P %QBASICTEMP%\HISTORIK.TMP\3\*.LST
PAUSE

:214_VGL
IF NOT EXIST %QBASICTEMP%\HISTORIK.TMP\4\*.* GOTO 223_VGL
FC %QBASICTEMP%\HISTORIK.TMP\1\*.HQL %QBASICTEMP%\HISTORIK.TMP\4\*.HQL | MORE
PAUSE
DIR /P %QBASICTEMP%\HISTORIK.TMP\1\*.LST
PAUSE
DIR /P %QBASICTEMP%\HISTORIK.TMP\4\*.LST
PAUSE

:223_VGL
IF NOT EXIST %QBASICTEMP%\HISTORIK.TMP\2\*.* GOTO 234_VGL
IF NOT EXIST %QBASICTEMP%\HISTORIK.TMP\3\*.* GOTO 224_VGL
FC %QBASICTEMP%\HISTORIK.TMP\2\*.HQL %QBASICTEMP%\HISTORIK.TMP\3\*.HQL | MORE
PAUSE
DIR /P %QBASICTEMP%\HISTORIK.TMP\2\*.LST
PAUSE
DIR /P %QBASICTEMP%\HISTORIK.TMP\3\*.LST
PAUSE

:224_VGL
IF NOT EXIST %QBASICTEMP%\HISTORIK.TMP\4\*.* GOTO 312_VGL
FC %QBASICTEMP%\HISTORIK.TMP\2\*.HQL %QBASICTEMP%\HISTORIK.TMP\4\*.HQL | MORE
PAUSE
DIR /P %QBASICTEMP%\HISTORIK.TMP\2\*.LST
PAUSE
DIR /P %QBASICTEMP%\HISTORIK.TMP\4\*.LST
PAUSE

:234_VGL
IF NOT EXIST %QBASICTEMP%\HISTORIK.TMP\4\*.* GOTO 312_VGL
FC %QBASICTEMP%\HISTORIK.TMP\3\*.HQL %QBASICTEMP%\HISTORIK.TMP\4\*.HQL | MORE
PAUSE
DIR /P %QBASICTEMP%\HISTORIK.TMP\3\*.LST
PAUSE
DIR /P %QBASICTEMP%\HISTORIK.TMP\4\*.LST
PAUSE
GOTO Ende


:312_VGL
IF NOT EXIST HISTORIK.TMP\1\*.* GOTO 323_VGL
IF NOT EXIST HISTORIK.TMP\2\*.* GOTO 313_VGL
FC HISTORIK.TMP\1\*.HQL HISTORIK.TMP\2\*.HQL | MORE
PAUSE
DIR /P HISTORIK.TMP\1\*.LST
PAUSE
DIR /P HISTORIK.TMP\2\*.LST
PAUSE

:313_VGL
IF NOT EXIST HISTORIK.TMP\3\*.* GOTO 314_VGL
FC HISTORIK.TMP\1\*.HQL HISTORIK.TMP\3\*.HQL | MORE
PAUSE
DIR /P HISTORIK.TMP\1\*.LST
PAUSE
DIR /P HISTORIK.TMP\3\*.LST
PAUSE

:314_VGL
IF NOT EXIST HISTORIK.TMP\4\*.* GOTO 323_VGL
FC HISTORIK.TMP\1\*.HQL HISTORIK.TMP\4\*.HQL | MORE
PAUSE
DIR /P HISTORIK.TMP\1\*.LST
PAUSE
DIR /P HISTORIK.TMP\4\*.LST
PAUSE

:323_VGL
IF NOT EXIST HISTORIK.TMP\2\*.* GOTO 334_VGL
IF NOT EXIST HISTORIK.TMP\3\*.* GOTO 324_VGL
FC HISTORIK.TMP\2\*.HQL HISTORIK.TMP\3\*.HQL | MORE
PAUSE
DIR /P HISTORIK.TMP\2\*.LST
PAUSE
DIR /P HISTORIK.TMP\3\*.LST
PAUSE

:324_VGL
IF NOT EXIST HISTORIK.TMP\4\*.* GOTO Ende
FC HISTORIK.TMP\2\*.HQL HISTORIK.TMP\4\*.HQL | MORE
PAUSE
DIR /P HISTORIK.TMP\2\*.LST
PAUSE
DIR /P HISTORIK.TMP\4\*.LST
PAUSE

:334_VGL
IF NOT EXIST HISTORIK.TMP\4\*.* GOTO Ende
FC HISTORIK.TMP\3\*.HQL HISTORIK.TMP\4\*.HQL | MORE
PAUSE
DIR /P HISTORIK.TMP\3\*.LST
PAUSE
DIR /P HISTORIK.TMP\4\*.LST
PAUSE
GOTO Ende


REM CODEPAGE auf Windows-Vorgabe oder anderen Wert zurcksetzen:
REM ------------------------------------------------------------
:Ende
IF x%WINDIR%x==xx GOTO 2_DosPfad
IF EXIST %WINDIR%\SYSTEM32\EGA.CPI GOTO EndeWindowsNT
IF EXIST %WINDIR%\COMMAND\EGA.CPI GOTO EndeWindows95
:2_DosPfad
IF EXIST %SYSTEMDRIVE%\DOS\EGA.CPI GOTO EndeDos
IF EXIST %DOSDIR%\CPI\EGA.CPX GOTO EndeFreeDos
GOTO Schluss
:EndeDos
MODE CON CODEPAGE PREPARE=((850) %SYSTEMDRIVE%\DOS\EGA.CPI)
KEYB GR,850,%SYSTEMDRIVE%\DOS\KEYBOARD.SYS
MODE CON CODEPAGE SELECT=850
GOTO Schluss
:EndeFreeDos
MODE CON CP PREP=((858) %DOSDIR%\CPI\EGA.CPX)
MODE CON CP SEL=858
MODE CON CP REFRESH
SET DIRCMD=/P /ONG /Y
GOTO Schluss
:EndeWindows95
MODE CON CODEPAGE PREPARE=((850) %WINDIR%\COMMAND\EGA.CPI)
IF EXIST %WINDIR\COMMAND\KEYB.COM KEYB GR,850,%WINDIR%\COMMAND\KEYBOARD.SYS
IF NOT EXIST %WINDIR%\COMMAND\KEYB.COM KEYBOARD GR,850,%WINDIR%\COMMAND\KEYBOARD.SYS
MODE CON CODEPAGE SELECT=850
GOTO Schluss
:EndeWindowsNT
MODE CON CODEPAGE PREPARE=((850) %WINDIR%\SYSTEM32\EGA.CPI)
REM KEYB GR,850,%WINDIR%\SYSTEM32\KEYBOARD.SYS
MODE CON CODEPAGE SELECT=850
CHCP 850

REM Eine Pause am Programmende sorgt fr Lesbarkeit aller Fehlermeldungen:
REM ----------------------------------------------------------------------
:Schluss
PAUSE

REM ===========================================================================
REM  Ende von HISTORIK.BAT
REM ===========================================================================
